#!/bin/bash
# By Xianur0 - xianur0.null@gmail.com
# Los Caballeros - http://hackingtelevision.blogspot.com/
ARQ=`uname -i`
NITE32="http://www.openni.org/downloadfiles/openni-compliant-middleware-binaries/stable/54-primesense-nite-beta-build-for-for-ubuntu-10-10-x86-32-bit-v1-3-0/download"
NITE64="http://www.openni.org/downloadfiles/openni-compliant-middleware-binaries/stable/53-primesense-nite-beta-build-for-for-ubuntu-10-10-x64-64-bit-v1-3-0/download"
ARQ1="i386"
NITE=""
OUTNITE="nite.tar.bz2"
DEPENDENCIAS=0
DEPEND="git-core cmake libglut3-dev pkg-config  build-essential libxmu-dev libxi-dev libusb-dev doxygen graphviz patch"
APT=1
ZYPPER=1
SSE3=1
echo "Buscando gestor de paquetes..."
apt-get -V || APT=0
zypper -V || ZYPPER=0

if [ $APT -eq 1 ]; then
	echo "Utilizando APT"
	apt-get install $DEPEND
	DEPENDENCIAS=1
fi
if [ $ZYPPER -eq 1 ] && [ $DEPENDENCIAS -eq 0 ]; then
	echo "Utilizando Zypper"
	zypper install $DEPEND
	DEPENDENCIAS=1
fi

if [ $DEPENDENCIAS -eq 0 ]; then
	echo "Error instalando dependencias, por favor instalar manualmente: " $DEPEND
	exit -1
fi

mkdir /usr/include/nite
mkdir /usr/include/ni
mkdir /usr/etc/primesense 
mkdir ~/kinect
cd ~/kinect
git clone https://github.com/OpenNI/OpenNI.git
cd OpenNI/Platform/Linux-x86/CreateRedist
./RedistMaker
cd ../Build
cat /proc/cpuinfo | grep ssse3
if [ $? -ne 0 ]; then
	echo "No hay soporte para SSSE3, parchando..."
	perl -i.back -p -e 'undef $/; s@(SSE_GENERATION =) 3@$1 2@sg' CommonMakefile
	SSE3=0
fi
./install.sh
cd ~/kinect/
git clone https://github.com/boilerbots/Sensor.git
cd Sensor
git checkout kinect
cd Platform/Linux-x86/Build
make && sudo make install
cd ~/kinect/
mkdir NITE
cd NITE
if [ $ARQ = $ARQ1 ]; then
	NITE=$NITE32
else
	NITE=$NITE64
fi
wget $NITE -O $OUTNITE
tar jvxf $OUTNITE
cd Nite-*
if [ $SSE3 -eq 0 ]; then
	echo "No hay soporte para SSSE3, parchando..."
	perl -i.back -p -e 'undef $/; s@(SSE_GENERATION =) 3@$1 2@sg' CommonMakefile
fi
cd Data
perl -i.back -p -e 'undef $/; s@insert key here@0KOIk2JeIBYClPWVnMoRKn5cdY4=@sg' *.xml
perl -i.back -p -e 'undef $/; s@xRes="320"@xRes="640"@sg' *.xml
perl -i.back -p -e 'undef $/; s@yRes="240"@yRes="480"@sg' *.xml
cd ../
perl -i.back -p -e 'undef $/; s@LIC_KEY=""@LIC_KEY="0KOIk2JeIBYClPWVnMoRKn5cdY4="@sg' install.bash
perl -i.back -p -e 'undef $/; s@ASK_LIC="1"@ASK_LIC="0"@sg' install.bash
./install.bash
make && sudo make install
cd Samples/Bin
chmod 777 Sample-Players
echo "Por favor conecte kinect y a continuacion presione cualquier tecla"
read
./Sample-Players
echo "Felicidades tienes Nite instalado! - By Los Caballeros"
